/// @cond EO_CXX_EO_IMPL

inline void evas_3d_mesh::frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
}

inline void evas_3d_mesh::frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
}

inline void * evas_3d_mesh::frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
   return _tmp_ret;
}

inline void evas_3d_mesh::frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
}

inline int evas_3d_mesh::frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
   return _tmp_ret;
}

inline void evas_3d_mesh::index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_set(format_, count_, indices_));
}

inline void evas_3d_mesh::index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
}

inline Evas_3D_Index_Format evas_3d_mesh::index_format_get() const
{
   Evas_3D_Index_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_format_get());
   return _tmp_ret;
}

inline int evas_3d_mesh::index_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_count_get());
   return _tmp_ret;
}

inline void * evas_3d_mesh::index_data_map() const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_data_map());
   return _tmp_ret;
}

inline void evas_3d_mesh::index_data_unmap() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_unmap());
}

inline void evas_3d_mesh::frame_add(int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_add(frame_));
}

inline void evas_3d_mesh::frame_del(int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_del(frame_));
}

inline void evas_3d_mesh::fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
}

inline void evas_3d_mesh::fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
}

inline void evas_3d_mesh::blending_func_set(Evas_3D_Blend_Func sfactor_, Evas_3D_Blend_Func dfactor_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_func_set(sfactor_, dfactor_));
}

inline void evas_3d_mesh::blending_func_get(Evas_3D_Blend_Func* sfactor_, Evas_3D_Blend_Func* dfactor_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_func_get(sfactor_, dfactor_));
}

inline Evas_3D_Shade_Mode evas_3d_mesh::shade_mode_get() const
{
   Evas_3D_Shade_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_shade_mode_get());
   return _tmp_ret;
}

inline void evas_3d_mesh::shade_mode_set(Evas_3D_Shade_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_shade_mode_set(mode_));
}

inline bool evas_3d_mesh::color_pick_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_color_pick_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_mesh::color_pick_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_color_pick_enable_set(::efl::eolian::to_c(enabled_)));
}

inline unsigned int evas_3d_mesh::vertex_count_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_count_get());
   return _tmp_ret;
}

inline void evas_3d_mesh::vertex_count_set(unsigned int count_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_vertex_count_set(count_));
}

inline bool evas_3d_mesh::fog_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_fog_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_mesh::fog_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_enable_set(::efl::eolian::to_c(enabled_)));
}

inline bool evas_3d_mesh::alpha_test_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_alpha_test_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_mesh::alpha_test_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_test_enable_set(::efl::eolian::to_c(enabled_)));
}

inline void evas_3d_mesh::alpha_func_get(Evas_3D_Comparison* comparison_func_, Evas_Real* ref_value_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_func_get(comparison_func_, ref_value_));
}

inline void evas_3d_mesh::alpha_func_set(Evas_3D_Comparison comparison_func_, Evas_Real ref_value_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_func_set(comparison_func_, ref_value_));
}

inline bool evas_3d_mesh::blending_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_blending_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_mesh::blending_enable_set(bool blending_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_enable_set(::efl::eolian::to_c(blending_)));
}

inline Evas_3D_Material * evas_3d_mesh::frame_material_get(int frame_) const
{
   Evas_3D_Material * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
   return _tmp_ret;
}

inline void evas_3d_mesh::frame_material_set(int frame_, Evas_3D_Material * material_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_material_set(frame_, material_));
}

inline Evas_3D_Vertex_Assembly evas_3d_mesh::vertex_assembly_get() const
{
   Evas_3D_Vertex_Assembly _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
   return _tmp_ret;
}

inline void evas_3d_mesh::vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_vertex_assembly_set(assembly_));
}

inline void eo_cxx::evas_3d_mesh::frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
}

inline void eo_cxx::evas_3d_mesh::frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
}

inline void * eo_cxx::evas_3d_mesh::frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
}

inline int eo_cxx::evas_3d_mesh::frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_) const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_set(format_, count_, indices_));
}

inline void eo_cxx::evas_3d_mesh::index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
}

inline Evas_3D_Index_Format eo_cxx::evas_3d_mesh::index_format_get() const
{
   Evas_3D_Index_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_format_get());
   return _tmp_ret;
}

inline int eo_cxx::evas_3d_mesh::index_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_count_get());
   return _tmp_ret;
}

inline void * eo_cxx::evas_3d_mesh::index_data_map() const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_index_data_map());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::index_data_unmap() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_index_data_unmap());
}

inline void eo_cxx::evas_3d_mesh::frame_add(int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_add(frame_));
}

inline void eo_cxx::evas_3d_mesh::frame_del(int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_del(frame_));
}

inline void eo_cxx::evas_3d_mesh::fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_mesh::fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_mesh::blending_func_set(Evas_3D_Blend_Func sfactor_, Evas_3D_Blend_Func dfactor_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_func_set(sfactor_, dfactor_));
}

inline void eo_cxx::evas_3d_mesh::blending_func_get(Evas_3D_Blend_Func* sfactor_, Evas_3D_Blend_Func* dfactor_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_func_get(sfactor_, dfactor_));
}

inline Evas_3D_Shade_Mode eo_cxx::evas_3d_mesh::shade_mode_get() const
{
   Evas_3D_Shade_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_shade_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::shade_mode_set(Evas_3D_Shade_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_shade_mode_set(mode_));
}

inline bool eo_cxx::evas_3d_mesh::color_pick_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_color_pick_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_mesh::color_pick_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_color_pick_enable_set(::efl::eolian::to_c(enabled_)));
}

inline unsigned int eo_cxx::evas_3d_mesh::vertex_count_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_count_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::vertex_count_set(unsigned int count_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_vertex_count_set(count_));
}

inline bool eo_cxx::evas_3d_mesh::fog_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_fog_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_mesh::fog_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_fog_enable_set(::efl::eolian::to_c(enabled_)));
}

inline bool eo_cxx::evas_3d_mesh::alpha_test_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_alpha_test_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_mesh::alpha_test_enable_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_test_enable_set(::efl::eolian::to_c(enabled_)));
}

inline void eo_cxx::evas_3d_mesh::alpha_func_get(Evas_3D_Comparison* comparison_func_, Evas_Real* ref_value_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_func_get(comparison_func_, ref_value_));
}

inline void eo_cxx::evas_3d_mesh::alpha_func_set(Evas_3D_Comparison comparison_func_, Evas_Real ref_value_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_alpha_func_set(comparison_func_, ref_value_));
}

inline bool eo_cxx::evas_3d_mesh::blending_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_blending_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_mesh::blending_enable_set(bool blending_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_blending_enable_set(::efl::eolian::to_c(blending_)));
}

inline Evas_3D_Material * eo_cxx::evas_3d_mesh::frame_material_get(int frame_) const
{
   Evas_3D_Material * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::frame_material_set(int frame_, Evas_3D_Material * material_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_frame_material_set(frame_, material_));
}

inline Evas_3D_Vertex_Assembly eo_cxx::evas_3d_mesh::vertex_assembly_get() const
{
   Evas_3D_Vertex_Assembly _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_mesh::vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_mesh_vertex_assembly_set(assembly_));
}

inline ::eo_cxx::evas_3d_mesh::operator ::evas_3d_mesh() const
{
   return *static_cast<::evas_3d_mesh const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_mesh::operator ::evas_3d_mesh&()
{
   return *static_cast<::evas_3d_mesh*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_mesh::operator ::evas_3d_mesh const&() const
{
   return *static_cast<::evas_3d_mesh const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_vertex_data_set(frame_, attrib_, stride_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_copy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_vertex_data_copy_set(frame_, attrib_, stride_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void * _evas_3d_mesh_frame_vertex_data_map_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   void * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->frame_vertex_data_map(frame_, attrib_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_frame_vertex_data_unmap_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_vertex_data_unmap(frame_, attrib_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int _evas_3d_mesh_frame_vertex_stride_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Vertex_Attrib attrib_)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->frame_vertex_stride_get(frame_, attrib_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_index_data_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Index_Format format_, int count_, const void * indices_)
{
   try
      {
         static_cast<T*>(self->this_)->index_data_set(format_, count_, indices_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_index_data_copy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Index_Format format_, int count_, const void * indices_)
{
   try
      {
         static_cast<T*>(self->this_)->index_data_copy_set(format_, count_, indices_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Index_Format _evas_3d_mesh_index_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Index_Format _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->index_format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
int _evas_3d_mesh_index_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->index_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void * _evas_3d_mesh_index_data_map_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   void * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->index_data_map();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_index_data_unmap_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->index_data_unmap();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_frame_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_add(frame_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_frame_del_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_del(frame_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_fog_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->fog_color_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_fog_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->fog_color_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_blending_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Blend_Func sfactor_, Evas_3D_Blend_Func dfactor_)
{
   try
      {
         static_cast<T*>(self->this_)->blending_func_set(sfactor_, dfactor_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_blending_func_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Blend_Func* sfactor_, Evas_3D_Blend_Func* dfactor_)
{
   try
      {
         static_cast<T*>(self->this_)->blending_func_get(sfactor_, dfactor_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Shade_Mode _evas_3d_mesh_shade_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Shade_Mode _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->shade_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_shade_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Shade_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->shade_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_mesh_color_pick_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->color_pick_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_color_pick_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->color_pick_enable_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
unsigned int _evas_3d_mesh_vertex_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   unsigned int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->vertex_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_vertex_count_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int count_)
{
   try
      {
         static_cast<T*>(self->this_)->vertex_count_set(count_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_mesh_fog_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->fog_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_fog_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->fog_enable_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_mesh_alpha_test_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->alpha_test_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_alpha_test_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->alpha_test_enable_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_alpha_func_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Comparison* comparison_func_, Evas_Real* ref_value_)
{
   try
      {
         static_cast<T*>(self->this_)->alpha_func_get(comparison_func_, ref_value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_mesh_alpha_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Comparison comparison_func_, Evas_Real ref_value_)
{
   try
      {
         static_cast<T*>(self->this_)->alpha_func_set(comparison_func_, ref_value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_mesh_blending_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->blending_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_blending_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool blending_)
{
   try
      {
         static_cast<T*>(self->this_)->blending_enable_set(::efl::eolian::to_cxx<bool>(blending_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Material * _evas_3d_mesh_frame_material_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_)
{
   Evas_3D_Material * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->frame_material_get(frame_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_frame_material_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_, Evas_3D_Material * material_)
{
   try
      {
         static_cast<T*>(self->this_)->frame_material_set(frame_, material_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Vertex_Assembly _evas_3d_mesh_vertex_assembly_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Vertex_Assembly _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->vertex_assembly_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_mesh_vertex_assembly_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Vertex_Assembly assembly_)
{
   try
      {
         static_cast<T*>(self->this_)->vertex_assembly_set(assembly_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_mesh >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
   {
      virtual void frame_vertex_data_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_set(frame_, attrib_, stride_, data_));
      }

      virtual void frame_vertex_data_copy_set(int frame_, Evas_3D_Vertex_Attrib attrib_, int stride_, const void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_copy_set(frame_, attrib_, stride_, data_));
      }

      virtual void * frame_vertex_data_map(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         void * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_vertex_data_map(frame_, attrib_));
            return _tmp_ret;
      }

      virtual void frame_vertex_data_unmap(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_vertex_data_unmap(frame_, attrib_));
      }

      virtual int frame_vertex_stride_get(int frame_, Evas_3D_Vertex_Attrib attrib_)
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_vertex_stride_get(frame_, attrib_));
            return _tmp_ret;
      }

      virtual void index_data_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_set(format_, count_, indices_));
      }

      virtual void index_data_copy_set(Evas_3D_Index_Format format_, int count_, const void * indices_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_copy_set(format_, count_, indices_));
      }

      virtual Evas_3D_Index_Format index_format_get()
      {
         Evas_3D_Index_Format _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_format_get());
            return _tmp_ret;
      }

      virtual int index_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_count_get());
            return _tmp_ret;
      }

      virtual void * index_data_map()
      {
         void * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_index_data_map());
            return _tmp_ret;
      }

      virtual void index_data_unmap()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_index_data_unmap());
      }

      virtual void frame_add(int frame_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_add(frame_));
      }

      virtual void frame_del(int frame_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_del(frame_));
      }

      virtual void fog_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_color_set(r_, g_, b_, a_));
      }

      virtual void fog_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_color_get(r_, g_, b_, a_));
      }

      virtual void blending_func_set(Evas_3D_Blend_Func sfactor_, Evas_3D_Blend_Func dfactor_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_blending_func_set(sfactor_, dfactor_));
      }

      virtual void blending_func_get(Evas_3D_Blend_Func* sfactor_, Evas_3D_Blend_Func* dfactor_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_blending_func_get(sfactor_, dfactor_));
      }

      virtual Evas_3D_Shade_Mode shade_mode_get()
      {
         Evas_3D_Shade_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_shade_mode_get());
            return _tmp_ret;
      }

      virtual void shade_mode_set(Evas_3D_Shade_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_shade_mode_set(mode_));
      }

      virtual bool color_pick_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_color_pick_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void color_pick_enable_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_color_pick_enable_set(::efl::eolian::to_c(enabled_)));
      }

      virtual unsigned int vertex_count_get()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_vertex_count_get());
            return _tmp_ret;
      }

      virtual void vertex_count_set(unsigned int count_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_vertex_count_set(count_));
      }

      virtual bool fog_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_fog_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void fog_enable_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_fog_enable_set(::efl::eolian::to_c(enabled_)));
      }

      virtual bool alpha_test_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_alpha_test_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void alpha_test_enable_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_alpha_test_enable_set(::efl::eolian::to_c(enabled_)));
      }

      virtual void alpha_func_get(Evas_3D_Comparison* comparison_func_, Evas_Real* ref_value_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_alpha_func_get(comparison_func_, ref_value_));
      }

      virtual void alpha_func_set(Evas_3D_Comparison comparison_func_, Evas_Real ref_value_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_alpha_func_set(comparison_func_, ref_value_));
      }

      virtual bool blending_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_blending_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void blending_enable_set(bool blending_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_blending_enable_set(::efl::eolian::to_c(blending_)));
      }

      virtual Evas_3D_Material * frame_material_get(int frame_)
      {
         Evas_3D_Material * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_frame_material_get(frame_));
            return _tmp_ret;
      }

      virtual void frame_material_set(int frame_, Evas_3D_Material * material_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_frame_material_set(frame_, material_));
      }

      virtual Evas_3D_Vertex_Assembly vertex_assembly_get()
      {
         Evas_3D_Vertex_Assembly _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_mesh_vertex_assembly_get());
            return _tmp_ret;
      }

      virtual void vertex_assembly_set(Evas_3D_Vertex_Assembly assembly_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_mesh_vertex_assembly_set(assembly_));
      }

   };
};


#ifdef EVAS_3D_MESH_PROTECTED
template<>
struct operation_description_class_size< ::evas_3d_mesh >
{
   static constexpr int value = 35 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value + operation_description_class_size<::efl::file >::value;
};

#else
template<>
struct operation_description_class_size< ::evas_3d_mesh >
{
   static constexpr int value = 35 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value + operation_description_class_size<::efl::file >::value;
};

#endif

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_mesh>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_copy_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_copy_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_map_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_map);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_data_unmap_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_data_unmap);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_vertex_stride_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_vertex_stride_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_copy_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_copy_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_format_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_format_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_count_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_count_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_map_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_map);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_index_data_unmap_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_index_data_unmap);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_add_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_add);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_del_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_del);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_color_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_color_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_color_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_color_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_blending_func_set_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_blending_func_set);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_blending_func_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_blending_func_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_shade_mode_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_shade_mode_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_shade_mode_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_shade_mode_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_color_pick_enable_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_color_pick_enable_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_color_pick_enable_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_color_pick_enable_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_count_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_count_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_count_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_count_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_enable_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_enable_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_fog_enable_set_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_fog_enable_set);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_alpha_test_enable_get_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_alpha_test_enable_get);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_alpha_test_enable_set_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_alpha_test_enable_set);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_alpha_func_get_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_alpha_func_get);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_alpha_func_set_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_alpha_func_set);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_blending_enable_get_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_blending_enable_get);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_blending_enable_set_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_blending_enable_set);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_material_get_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_material_get);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   ops[32].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_frame_material_set_wrapper<T>);
   ops[32].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_frame_material_set);
   ops[32].op = EO_OP_OVERRIDE;
   ops[32].op_type = EO_OP_TYPE_REGULAR;
   ops[32].doc = NULL;

   ops[33].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_assembly_get_wrapper<T>);
   ops[33].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_assembly_get);
   ops[33].op = EO_OP_OVERRIDE;
   ops[33].op_type = EO_OP_TYPE_REGULAR;
   ops[33].doc = NULL;

   ops[34].func = reinterpret_cast<void*>(& ::_evas_3d_mesh_vertex_assembly_set_wrapper<T>);
   ops[34].api_func = reinterpret_cast<void*>(& ::evas_3d_mesh_vertex_assembly_set);
   ops[34].op = EO_OP_OVERRIDE;
   ops[34].op_type = EO_OP_TYPE_REGULAR;
   ops[34].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[operation_description_class_size< ::evas_3d_mesh >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[operation_description_class_size< ::evas_3d_mesh >::value + operation_description_class_size<::evas_3d_object>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::evas_3d_mesh >::value + operation_description_class_size<::evas_3d_object>::value + operation_description_class_size<::evas::common_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::evas_3d_mesh>)
{
   return (EVAS_3D_MESH_CLASS);
}

} } }

/// @endcond

